Summary: Signing utility for UEFI binaries
Name:    pesign
Version: 116
Release: 3%{?dist}
License: GPL-2.0-only
URL:     https://github.com/rhboot/pesign
Source0: %{url}/releases/download/%{version}/pesign-%{version}.tar.bz2
# download from fedora pesign src rpm file
Source1: certs.tar.xz
Source2: pesign.py

Patch3000:     Bugfix-cms_common-fix-cert-match-check.patch
Patch3001:     cms_common-Fixed-Segmentation-fault.patch
Patch3002:     pesign-support-SM3-digest-algorithm.patch
Patch3003:     pesign-support-SM2-signature-algorithm.patch
Patch3004:     Fix-build-error-of-gcc-version-too-low.patch

BuildRequires: efivar-devel gcc git libuuid-devel make mandoc nspr nspr-devel nss
BuildRequires: nss-devel nss-tools nss-util popt-devel python3 python3-rpm-macros
BuildRequires: tar xz systemd-rpm-macros

Requires:      nspr nss nss-tools nss-util popt rpm
Requires(pre): shadow-utils

ExclusiveArch: x86_64 aarch64

%description
This package contains the pesign utility for signing UEFI binaries as well as other associated tools.

%prep
%autosetup -n %{name}-%{version} -p1 -T -b 0 -D -c -a 1

%build
make PREFIX=%{_prefix} LIBDIR=%{_libdir} CFLAGS="${CFLAGS} -Wno-error" CPPFLAGS="${CPPFLAGS} -Wno-error"

%install
mkdir -p %{buildroot}/%{_libdir}
make PREFIX=%{_prefix} LIBDIR=%{_libdir} INSTALLROOT=%{buildroot} \
	install
make PREFIX=%{_prefix} LIBDIR=%{_libdir} INSTALLROOT=%{buildroot} \
	install_systemd

rm -rf %{buildroot}/boot %{buildroot}/usr/include
rm -rf %{buildroot}%{_libdir}/libdpe*
mkdir -p %{buildroot}%{_sysconfdir}/pki/pesign/
mkdir -p %{buildroot}%{_sysconfdir}/pki/pesign-rh-test/
cp -a etc/pki/pesign/* %{buildroot}%{_sysconfdir}/pki/pesign/
cp -a etc/pki/pesign-rh-test/* %{buildroot}%{_sysconfdir}/pki/pesign-rh-test/

install -D %{buildroot}%{_sysconfdir}/rpm/macros.pesign %{buildroot}%{_rpmconfigdir}/macros.d/macros.pesign
rm -rf %{buildroot}%{_sysconfdir}/rpm
rm -vf %{buildroot}/usr/share/doc/pesign-%{version}/COPYING

cp -av libdpe/*.[ch] src/

install -Dm 0755 %{SOURCE2} %{buildroot}%{python3_sitelib}/mockbuild/plugins/pesign.py

%pre
getent group pesign >/dev/null || groupadd -r pesign
getent passwd pesign >/dev/null || \
	useradd -r -g pesign -d /run/pesign -s /sbin/nologin \
		-c "Group for the pesign signing daemon" pesign
exit 0

%post
%systemd_post pesign.service

%preun
%systemd_preun pesign.service

%postun
%systemd_postun_with_restart pesign.service

%posttrans
certutil -d %{_sysconfdir}/pki/pesign/ -X -L > /dev/null

%files
%license COPYING
%doc README.md TODO
%dir %{_libexecdir}/pesign/
%dir %attr(0770,pesign,pesign) %{_sysconfdir}/pki/pesign/
%dir %attr(0775,pesign,pesign) %{_sysconfdir}/pki/pesign-rh-test/
%config(noreplace) %attr(0660,pesign,pesign) %{_sysconfdir}/pki/pesign/*
%config(noreplace) %attr(0664,pesign,pesign) %{_sysconfdir}/pki/pesign-rh-test/*
%config(noreplace)/%{_sysconfdir}/pesign/users
%config(noreplace)/%{_sysconfdir}/pesign/groups
%dir %attr(0770, pesign, pesign) %{_rundir}/%{name}
%ghost %attr(0660, -, -) %{_rundir}/%{name}/socket
%ghost %attr(0660, -, -) %{_rundir}/%{name}/pesign.pid
%{_bindir}/authvar
%{_bindir}/efikeygen
%{_bindir}/pesigcheck
%{_bindir}/pesign
%{_bindir}/pesum
%{_bindir}/pesign-client
%{_libexecdir}/pesign/pesign-authorize
%{_libexecdir}/pesign/pesign-rpmbuild-helper
%{_rpmconfigdir}/macros.d/macros.pesign
%{_sysconfdir}/popt.d/pesign.popt
%{_tmpfilesdir}/pesign.conf
%{_unitdir}/pesign.service
%{python3_sitelib}/mockbuild/plugins/*/pesign.*
%{python3_sitelib}/mockbuild/plugins/pesign.*
%{_mandir}/man*/*

%changelog
* Tue Oct 10 2023 wynnfeng <wynnfeng@tencent.com> - 116-3
- support SMx and fix some bugs

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 116-2
- Rebuilt for OpenCloudOS Stream 23.09

* Wed Jul 12 2023 kianli <kianli@tencent.com> - 116-1
- Upgrade to 116

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 114-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 114-2
- Rebuilt for OpenCloudOS Stream 23

* Wed Nov 23 2022 Shuo Wang <abushwang@tencent.com> - 114-1
- initial build
